unit iMisc;

interface

uses
    Windows, Messages, Forms, Graphics, psapi, Classes, SysUtils;

//  ---------------------------------------------------------------------------
const
    CUR_SEEKER = 1;
    CURSEEK = 'CUR_SEEK';
//  ---------------------------------------------------------------------------
procedure InfoOk(const S: string);
//  ---------------------------------------------------------------------------
procedure FlashDesktopCanvas(const Target: HWND; const Interval: integer);
procedure PrintModules(AProcID: Cardinal; AResults: TStrings);

implementation

{$R Extra.res}

(*
    ===========================================================================
    vZXIDɊ֌W郂W[tpX
    ---------------------------------------------------------------------------
    XP, 2003, 2000(Pro/Svr), NT(WS/Svr) 
    ---------------------------------------------------------------------------
    ms-help://MS.PSDK.1033/perfmon/base/enumerating_all_modules_for_a_process.htm
    ===========================================================================
*)
procedure   PrintModules(AProcID: Cardinal; AResults: TStrings);
const
    MAX_HMODULE = 1024;
var
    DesiredAccess: Cardinal;                        //  tO
    ModHandle : array[0..MAX_HMODULE-1] of HMODULE; //  W[nh
    ProcHandle: THandle;                            //  vZXnh
    cbNeeded  : DWORD;                              //  z̑傫
    i         : integer;
    p         : PChar;
//    ModNameLen: integer;                            //  W[
    ModName   : string;                             //  W[
begin
    //  Ƃ肠vZXIDo͂Ă
    AResults.Add(Format('Process ID: %d', [AProcID]));
    //  ^Cgo
    AResults.Add('------------+--------------------+------------------------');
    AResults.Add(Format('(%10s) %-20s %s', ['Handle', 'Module Name', 'Full Path']));
    AResults.Add('------------+--------------------+------------------------');
    //  vZX̃nho
    DesiredAccess := PROCESS_QUERY_INFORMATION or PROCESS_VM_READ;
    ProcHandle := OpenProcess(DesiredAccess, false, AProcID);
    //  sH
    if (ProcHandle = INVALID_HANDLE_VALUE) then
    begin
        Exit;
    end
    //  I
    else
    begin
        try
            //  ̃vZX̑SẴW[̃Xg擾(pspi.dll)
            if (EnumProcessModules(ProcHandle, @ModHandle, MAX_HMODULE, cbNeeded)) then
            begin
                //  W[̌JԂ܂傤
                for i := 0 to (cbNeeded div sizeof(HMODULE)) - 1 do
                begin
                    //  m
                    GetMem(p, MAX_PATH);
                    //  W[t@C̃tpX擾
//                    ModNameLen := GetModuleFileNameEx(ProcHandle, ModHandle[i], p, MAX_FILENAME);
                    GetModuleFileNameEx(ProcHandle, ModHandle[i], p, MAX_PATH);
                    //  
//                    SetString(ModName, p, ModNameLen);
                    ModName := String(p);
                    //  
                    FreeMem(p);
                    //  Xgɒǉ
                    AResults.Add(Format('(%10d) %-20s %s', [ModHandle[i], ExtractFileName(ModName), ModName]));
                end;
            end;
        finally
            //  J߂
            CloseHandle(ProcHandle);
        end;
    end;
end;

//------------------------------------------------------------------------------
procedure InfoOk(const S: string);
var F: integer;
begin
    F := MB_OK + MB_ICONINFORMATION;
    Application.MessageBox(PChar(S), PChar(Application.Title), F);
end;

//  ---------------------------------------------------------------------------
//  w肵nhEBhẺ`悷
procedure FlashDesktopCanvas(const Target: HWND; const Interval: integer);
var
    DesktopDC: HDC;
    RT: TRect;
    WI: TWindowInfo;
    DesktopCanvas: TCanvas;
begin
    //  fXNgbṽfoCXReLXg擾
    DesktopDC := GetDC(0);
    if (DesktopDC <> INVALID_HANDLE_VALUE) then
    begin
        DesktopCanvas := TCanvas.Create;
        try
            //  O
            DesktopCanvas.Handle := DesktopDC;
            DesktopCanvas.Pen.Width := 3;
            DesktopCanvas.Pen.Mode := pmNotXor;
            //  EBhE擾
            if GetWindowInfo(Target, WI) then
            begin
                //  NCAg̈擾
                RT := WI.rcWindow;
                //  fXNgbvɋ``(XOR)
                DesktopCanvas.Rectangle(RT);
                //  ΂҂
                Sleep(Interval);
                //  fXNgbvɋ``(XOR)
                DesktopCanvas.Rectangle(RT);
            end;
        finally
            //  fXNgbṽfoCXReLXgj
            DesktopCanvas.Free;
            ReleaseDC(0, DesktopDC);
        end;
    end;
end;

//  ---------------------------------------------------------------------------
//  
initialization
    //  J[\Ǎ
    Screen.Cursors[CUR_SEEKER] := LoadCursor(HInstance, CURSEEK);
finalization
    ;
end.

